/***************************************************************
* file name			: stm32f10x_user.c

* Description   : ʼɲüɸɳʼ
									

* Author    		: zc

* Version				: 0.1

* Date					: 2015.8.4

* History       
***************************************************************/

#include "user_config.h"

/****************************************************************
* function   	: BSP_Init()

* Description : ϵͳʼ

* input			  : 

* output      : 
*****************************************************************/
void BSP_Init(void)
{
#if USE_RCC_PER
	RCC_UserConfig();
#endif
	
#if USE_LED_PER
	LED_UserConfig();
#endif
	
#if USE_KEY_PER
	KEY_UserConfig();
#endif

#if USE_USART1_PER
	 USART1_UserConfig();
#endif

#if USE_SYSTICK_PER
	SysTick_UserConfig();
#endif

#if USE_NVIC_PER
	NVIC_UserConfig();
#endif
}

/****************************************************************
* function   	: RCC_UserConfig()

* Description : ϵͳʱӳʼ
                Ŀǰʱ50MHZ, ͨRCC_CFGR2ʵʱ72MHZ

* input			  : 

* output      : 
*****************************************************************/
#if USE_RCC_PER
static void RCC_UserConfig(void)
{
  ErrorStatus HSEStartUpStatus;
	RCC_DeInit();                                           
	
	/*ⲿپ*/
	RCC_HSEConfig(RCC_HSE_ON);                              
  HSEStartUpStatus = RCC_WaitForHSEStartUp();               
	if (HSEStartUpStatus == SUCCESS)                        
	{
		/*ʱģ*/
    RCC_HCLKConfig(RCC_SYSCLK_Div1);                      //AHBCLK = SYSCLK
	  RCC_PCLK2Config(RCC_HCLK_Div1);                       //APB2CLK2 = AHBCLK
		RCC_PCLK1Config(RCC_HCLK_Div2);                       //APB1CLK = AHBCLK/2
			  
		/*μ΢ֲ2.3.3˵ϵͳʱӹflashҪӵȴʱ*/
	  FLASH_SetLatency(FLASH_Latency_2);                    
		
		/*AHBƵϵ1ҪRCC_CFGRĴ74λ˵*/
	  FLASH_PrefetchBufferCmd(FLASH_PrefetchBuffer_Enable); 
		
		/*stm32ϵƵγòҪ72MHZ*/
		/*SYSTICK = (HSE_CLK/RCC_DIV)*RCC_PLL*/		
		RCC_PLLConfig(RCC_PLLSource_PREDIV2, RCC_PLLMul_4);   
		
		/*ʹPLLȴPLLɹΪϵͳʱӣȴɹ*/
	  RCC_PLLCmd(ENABLE);                                   
		while (RCC_GetFlagStatus(RCC_FLAG_PLLRDY) == RESET)   
		{
			//ӳʱֹ⿨ڲԭ
		}
		RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK);            
		while (RCC_GetSYSCLKSource() != 0x08)                 
		{
			//ͬ
		}
	}
}
#endif		

/****************************************************************
* function   	: LED_UserConfig()

* Description : LEDʼԭͼùܽ
								Ϊ˷ֲͷļض

* input			  : 

* output      : 
*****************************************************************/
#if USE_LED_PER
static void LED_UserConfig(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;
	
	/*ʹʱӣԺע*/
	RCC_APB2PeriphClockCmd(RCC_LED_GPIO, ENABLE);   
	
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;        
	GPIO_InitStructure.GPIO_Pin = GPIO_LED_ALL;             //ѡLEDĶ˿ڣɸʵҪ 
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;       //趨GPIOƵ
	GPIO_Init(GPIO_LED, &GPIO_InitStructure); 
	
	GPIO_SetBits(GPIO_LED, GPIO_LED_ALL);
}
#endif

/****************************************************************
* function   	: Key_UserConfig()

* Description : keyʼԭͼùܽ

* input			  : 

* output      : 
*****************************************************************/
#if USE_KEY_PER
static void KEY_UserConfig(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;
	RCC_APB2PeriphClockCmd(RCC_KEY_GPIO, ENABLE);        
	
	/*,Ĭϸߵƽ*/
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;                   
	
	GPIO_InitStructure.GPIO_Pin = GPIO_KEY_Pin1 | GPIO_KEY_Pin3;          
	GPIO_Init(GPIO_KEY1_KEY3, &GPIO_InitStructure);    
	
	GPIO_InitStructure.GPIO_Pin = GPIO_KEY_Pin2;
	GPIO_Init(GPIO_KEY2, &GPIO_InitStructure);   
	
	GPIO_InitStructure.GPIO_Pin = GPIO_KEY_Pin4;   										 
	GPIO_Init(GPIO_KEY4, &GPIO_InitStructure);          								
}
#endif

/****************************************************************
* function   	: USART1_UserConfig()

* Description : USART1ʼ, ڴͨѶ, Ӧ˿PA9,PA10

* input			  : 

* output      : 
*****************************************************************/
#if USE_USART1_PER
static void USART1_UserConfig(void)
{
	USART_InitTypeDef USART_InitStructure;
	GPIO_InitTypeDef GPIO_InitStructure;
	USART_DeInit(USART1);
	
	RCC_APB2PeriphClockCmd(RCC_USART1, ENABLE);            
	
  GPIO_InitStructure.GPIO_Pin = USART1_TX_Pin;                
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;                 //ô1Ϊ
  GPIO_Init(USART1_TX,&GPIO_InitStructure);	
	
  GPIO_InitStructure.GPIO_Pin = USART1_RX_Pin;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;           //ô1Ϊ
  GPIO_Init(USART1_RX, &GPIO_InitStructure);
 
	USART_InitStructure.USART_BaudRate = 115200;                    //ôڲΪ115200
  USART_InitStructure.USART_WordLength = USART_WordLength_8b;     ///8λλ
  USART_InitStructure.USART_StopBits = USART_StopBits_1;          //ôֹͣλΪ1λ
  USART_InitStructure.USART_Parity = USART_Parity_No;             //żУ
  USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None; //Ӳ
  USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx; //1
	
  USART_Init(USART1, &USART_InitStructure);
  USART_Cmd(USART1, ENABLE);	                                 		//ʹܴڣʼշ
}
#endif
/****************************************************************
* function   	: Systick_UserConfig()

* Description :	ϵͳδʱ

* input			  : 

* output      : 
*****************************************************************/
#if USE_SYSTICK_PER
static void SysTick_UserConfig(void)
{
	SysTick->CTRL &= 0xfffffffb;  //ںⲿʱӣSYSTICK
  SysTick->LOAD = 0x8000;       //װֵĴVALֵΪ0ʱװ 
  SysTick->VAL = 0x00;  				//SysTickǰֵĴ 
  SysTick->CTRL = 0x03;					//SysTickʱʹܣжʹ
}
#endif

/****************************************************************
* function   	: NVIC_UserConfig()

* Description :	жʼ

* input			  : 

* output      : 
*****************************************************************/
#if USE_NVIC_PER
static void NVIC_UserConfig(void)
{
	NVIC_SetVectorTable(NVIC_VectTab_FLASH,0x0);      //ָָflashежΪ׼
}
#endif
/****************************************************************
* function   	: ARM_DELAY

* Description : ʱ

* input			  : i: 32λ

* output      : 
*****************************************************************/
void ARM_DELAY(_IO uint32_t i)
{
	for(;i>0;i--)
	{
	}
}

/***************************************end*******************************************/
